    program main

      implicit none

      integer(4) :: nn = 10
      integer(4) :: m, n
      character(len=64) :: cnum1, cnum2, cnum3

      do n = 1, nn
         write( cnum1, '(i)' ) 2+2
         write( cnum2, '(i)' ) 2+2*(n+1)+2
         write( cnum3, '(i)' ) 2+2*(n+1)+2
         call modline( cnum1 )
         call modline( cnum2 )
         call modline( cnum3 )

         if( n .eq. 1 ) then
            write( 6, '(a,i3.3,a)' ) &
                 'plot "out/int_flux_', n, '" u (($'//trim(cnum1)//'-$'//trim(cnum2)//')/($'//trim(cnum3)//'+1e-20)*100):2 w l'
         else
            write( 6, '(a,i3.3,a)' ) &
                 'replot "out/int_flux_', n, '" u (($'//trim(cnum1)//'-$'//trim(cnum2)//')/($'//trim(cnum3)//'+1e-20)*100):2 w l'
         end if
      end do

      write( 6, * ) 'pause -1'

      do n = 1, nn

         do m = 1, n

            write( cnum1, '(i)' ) 2+2+2*m
            write( cnum2, '(i)' ) 2+2+2*n+2+2*m
            write( cnum3, '(i)' ) 2+2+2*n+2+2*m
            call modline( cnum1 )
            call modline( cnum2 )
            call modline( cnum3 )

            if( m .eq. 1 ) then
               write( 6, '(a,i3.3,a)' ) &
                    'plot "out/int_flux_', n, '" u (($'//trim(cnum1)//'-$'//trim(cnum2)//')/($'//trim(cnum3)//'+1e-20)*100):2 w l'
            else
               write( 6, '(a,i3.3,a)' ) &
                    'replot "out/int_flux_', n, '" u (($'//trim(cnum1)//'-$'//trim(cnum2)//')/($'//trim(cnum3)//'+1e-20)*100):2 w l'
            end if
         end do

         write( 6, * ) 'pause -1'

      end do


!!$            write( fu, * ) k, gph( k ), &
!!$                 ( uwflh_sum_pfcbin ( k, iwndiv_pfc2, iwndiv_pfc ), &
!!$                   dwflh_sum_pfcbin ( k, iwndiv_pfc2, iwndiv_pfc ), &
!!$                   iwndiv_pfc2 = 0, iwndiv_pfc ), &
!!$                 uwflh_sum( k, 0 ), &
!!$                 dwflh_sum( k, 0 ), &
!!$                 ( uwflh_sum_pfcbin0( k, iwndiv_pfc2, iwndiv_pfc ), &
!!$                   dwflh_sum_pfcbin0( k, iwndiv_pfc2, iwndiv_pfc ), &
!!$                   iwndiv_pfc2 = 1, iwndiv_pfc )


    end program main

    !**************************************************************************

    subroutine modline( line )

      character(len=*), intent(inout) :: line


      le = len_trim( line )
      do l = 1, le
         if( line( l:l ) .ne. ' ' ) exit
      end do
      ls = l
      if( ls .le. le ) then
         line( 1:le-ls+1 ) = line( ls:le )
         do l = le-ls+1+1, le
            line( l:l ) = ' '
         end do
      end if

      
    end subroutine modline

