c******************************************************************************
c     real*8 function renorm
c     Renormalize Line Shape
c******************************************************************************

      real*8 function renorm(pi,lowid,dowid,wnmax)

      implicit none

      real*8 pi
      real*8 lowid,dowid
      real*8 wnmax

      real*8 wn
      real*8 dwn,tmpdwn
      real*8 val1,val2

      real*8 voigt

      dwn=dowid/5.0d0

      renorm=0.0d0
      do wn=0.0d0,wnmax,dwn
         if(wn.gt.wnmax) then
            tmpdwn=wnmax-(wn-dwn)
         else
            tmpdwn=dwn
         endif
         if(wn.eq.0.0d0) then
            val1=voigt(pi,lowid,dowid,dabs(wn))
         else
            val2=voigt(pi,lowid,dowid,dabs(wn))
            renorm=renorm+(val1+val2)*tmpdwn/2.0d0
            val1=val2
         endif
      enddo
      renorm=renorm*2.0d0

      renorm=1.0d0/renorm

      return
      end
