require "numru/ggraph"
include NumRu


ncfns = [
  "../out_hitemp_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_abw1.0/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_nocia/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_noxsc/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_co2co025/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_co2co100/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_co2co250/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
]
labels = [
  'control',
  'air-broadening width x 1.0',
  'no CIA',
  'no XSC',
  'CO2 cutoff 25 cm|-1"',
  'CO2 cutoff 100 cm|-1"',
  'CO2 cutoff 250 cm|-1"',
]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-60_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-50_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-40_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-30_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitran_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#]
#labels = [
#  'control',
#  'S cutoff 10|-60" m(molecule)|-1"',
#  'S cutoff 10|-50" m(molecule)|-1"',
#  'S cutoff 10|-40" m(molecule)|-1"',
#  'S cutoff 10|-30" m(molecule)|-1"',
#  'HITRAN',
#]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e2/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e0/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#]
#labels = [
#  DCL::csgi(131)+'k=1 cm|-1"',
#  'control ('+DCL::csgi(131)+'k=0.1 cm|-1")',
#  DCL::csgi(131)+'k=0.01 cm|-1"',
#]

#labels = [
#  'model',
#]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1_3spc/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_SO2_Flux.nc",
#  "../../../../radmodels-2018-01-23_test_Venus_Gas-Pollack/k-dist/prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza065.6_wn10000e2-25000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#]
#labels = [
#  'control',
#  'H2O, CO2, SO2 only',
#  'gas vmrs by Pollack et al. (1993)',
#]


ncfnobsup = "data/Venus_SWUpFluxProfile_Tomasko-etal1980.nc"
vname = "upflux"
gpobsup = GPhys::IO.open( ncfnobsup, vname )
ncfnobsdn = "data/Venus_SWDnFluxProfile_Tomasko-etal1980.nc"
vname = "dnflux"
gpobsdn = GPhys::IO.open( ncfnobsdn, vname )


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)


#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)
DCL.sglset('LCLIP', true)
DCL.sglset('LCNTL', true)

GGraph.set_fig 'itr'=>2, 'viewport'=>[0.1,0.9,0.15,0.65], 'window'=>[0.0,500,100e5,0.1e5]

gpobsup = gpobsup.copy
gpobsup.long_name = 'radiative flux'
z = gpobsup.axis('plev').pos
z.long_name = 'pressure'
gpobsup.axis('plev').set_pos(z)

GGraph.line gpobsup, true, 'exchange'=>true, 'index'=>11, 'type'=>2, 'legend'=>'observation: upward flux', 'legend_vx'=>0.45, 'legend_vy'=>0.475, 'title'=>''
GGraph.line gpobsdn, false, 'exchange'=>true, 'index'=>15, 'type'=>2, 'legend'=>'observation: downward flux', 'legend_vx'=>0.45

for ifile in 0..(ncfns.size-1)
  ncfn = ncfns[ifile]

  if ifile == 0 then
    flag_first = true
  else
    flag_first = false
  end

  vname = "RadUwFlux"
  gpup = GPhys::IO.open( ncfn, vname )
  vname = "RadDwFlux"
  gpdn = GPhys::IO.open( ncfn, vname )

  GGraph.line gpup, false, 'exchange'=>true, 'index'=>(ifile+1)*10+1, 'legend'=>labels[ifile]+': upward flux', 'legend_vx'=>0.45
  GGraph.line gpdn, false, 'exchange'=>true, 'index'=>(ifile+1)*10+5, 'legend'=>labels[ifile]+': downward flux', 'legend_vx'=>0.45

end

DCL.grcls
