require "numru/ggraph"
include NumRu

def mkwlobj( gp )

  namelev = "WaveNum"
  wn = gp.coord(namelev)

  gp = gp.copy
  wl = 1.0/wn

  gp = gp / wl**2
  #  gp = gp * wl

  #  wl = wl.convert_units( Units['micron'] )
  wl.long_name = "wavelength"
  vawl = wl.convert_units( Units['micron'] )
  #  vawl = VArray.new( wl.val, { "long_name"=>'wavelength', "units"=>wl.units.to_s }, namelev )
  gp.axis(namelev).set_pos(vawl)

  gp.long_name = "flux"

  # conversion from W m-2 m-1 to W m-2 (micron)-1
  gp = gp * 1e-6
  # conversion from W m-2 (micron)-1 to W m-2 (micron)-1 (sr)-1
#  gp = gp / 3.141592
#  gp.units = 'Wm|-2"(micron)|-1"'
  gp.units = 'Wm-2(micron)-1'
#    gp.units = 'Wm|-2"(micron)|-1"(sr)|-1"'
#  gp.units = 'Wm|-2"('+DCL::csgi(163)+'m)|-1"'

  return gp
end
