require "numru/ggraph"
include NumRu

flaglog = true
#flaglog = false

#wn1 = 852e2
#wn2 = 853e2
wn1 =  400e2
wn2 = 2000e2
#wn1 =  950e2
#wn2 = 1000e2
#wn1 = 1235e2
#wn2 = 1236e2
#wn1 = 1550e2
#wn2 = 1600e2
#wn1 = 1590e2
#wn2 = 1600e2
#wn1 =  950e2
#wn2 = 1000e2
#wn1 =  476e2
#wn2 =  477e2
#wn1 =  800e2
#wn2 = 1200e2

abscoefthreshold = 1e-26

ncfn  = "data1.nc"
#ncfn  = "data1-modified.nc"
ncfn  = "data1_case20.nc"
ncfn  = "data1_case20-hit12.nc"
ncfn  = "data1_case19-hit12.nc"
#ncfn  = "data1_delod1_1576-hit12.nc"
#ncfn  = "data1_delod1_984-hit12.nc"
ncfn  = "data1_delod005_case19-hit12.nc"
#ncfn  = "data1_delod005_h2oonly-iso296-1e-3-hit12.nc"
#ncfn  = "data1_delod007_h2oonly-iso296-1e-3-hit12.nc"
#ncfn  = "data1_delod005_h2oonly-iso250-1e-3-hit12.nc"
#ncfn  = "data1_delod001_h2oonly-iso250-1e-3-hit12.nc"
vname = "value"
gphys0 = GPhys::IO.open( ncfn, vname )
gphys0 = gphys0.cut("wn"=>wn1..wn2)
colden0 = 2.3166947E+24 * 1.0e4
colden0 = 2.3174016E+24 * 1.0e4
colden0 = 3.8138349E+22 * 1.0e4 # H2O Only layer 1
colden0 = 4.6385378E+21 * 1.0e4 # H2O Only layer 5
#colden0 = 2.3520155E+21 * 1.0e4 # H2O Only layer 5 for 296 K iso
#colden0 = 1.5683362E+21 * 1.0e4 # H2O Only layer 5 for 250 K iso
#colden0 = 2.3529507E+21 * 1.0e4 # H2O Only layer 1 for 250 K iso

gphys0 = gphys0 / colden0

ncfn  = "data1_case20-hit12.nc"
ncfn  = "data1_delod005_case20-hit12.nc"
#ncfn  = "data1_delod005_h2oonly-nocnt-iso296-1e-3-hit12.nc"
#ncfn  = "data1_delod007_h2oonly-nocnt-iso296-1e-3-hit12.nc"
#ncfn  = "data1_delod005_h2oonly-nocnt-iso250-1e-3-hit12.nc"
#ncfn  = "data1_delod001_h2oonly-nocnt-iso250-1e-3-hit12.nc"
vname = "value"
gphystmp = GPhys::IO.open( ncfn, vname )
gphystmp = gphystmp.cut("wn"=>wn1..wn2)
gphystmp = gphystmp / colden0
gphys0 = gphys0 - gphystmp

p  = 95750
p  = 59100 # level 5
#p  = 45650 # level 7
#grav = 9.80665
#mmr = 2.8758911851455217E-002
#avogn = 6.022140857e23
#vmr1 = 0.0187514704586114
#vmr2 = 0.0137988787636849
#ncfn  = "out-dwn1e0-0010-2000/LW_Case27_Earth_MidLatSummer_CO2-300ppmv_Spectral_Flux.nc"
#ncfn  = "out-dwn1e0-0400-2000/LW_Case20_Earth_MidLatSummer_H2OOnly_Spectral_Flux.nc"
#ncfn  = "out-dwn1e0-0400-2000/LW_Case19_Earth_MidLatSummer_H2OOnly_Spectral_Flux.nc"
#vname = "DelOptDep"
#gphys1 = GPhys::IO.open( ncfn, vname )
#gphys1 = gphys1.cut("PressLC"=>p).cut("WaveNum"=>wn1..wn2)
#colden = (delp)/grav / (mmr/avogn) * (vmr1+vmr2)/2
#gphys1 = gphys1 / colden
#
#colden1 = colden
#p colden0
#p colden1
#p 1-colden0/colden1

ncfn  = "../prog02.0_calc_ac/out-dwn1e0/LW_Case20_Earth_MidLatSummer_H2OOnly_ac.nc"
ncfn  = "../prog02.0_calc_ac/out-dwn1e0/LW_Case19_Earth_MidLatSummer_H2OOnly_ac.nc"
#ncfn  = "../prog02.0_calc_ac-selected-lines-1576/out-dwn1e0/LW_Case20_Earth_MidLatSummer_H2OOnly_ac.nc"
#ncfn  = "../prog02.0_calc_ac-selected-lines-984/out-dwn1e0/LW_Case20_Earth_MidLatSummer_H2OOnly_ac.nc"
#ncfn  = "../prog02.0_calc_ac/out/Test_Earth_Iso296K_H2O-1e-3_ac.nc"
#ncfn  = "../prog02.0_calc_ac/out/Test_Earth_Iso250K_H2O-1e-3_ac.nc"
vname = "AbsCoef"
gphys1 = GPhys::IO.open( ncfn, vname )
gphys1 = gphys1.cut('MolNum'=>1)
gphys1 = gphys1.cut("WaveNum"=>wn1..wn2)
p gphys1.coord('Press').val
gphys1 = gphys1.cut("Press"=>p)

ncfn  = "../prog02.0_calc_ac/out-dwn1e0/LW_Case20_Earth_MidLatSummer_H2OOnly_ac.nc"
gphys1tmp = GPhys::IO.open( ncfn, vname )
gphys1tmp = gphys1tmp.cut('MolNum'=>1).cut("WaveNum"=>wn1..wn2).cut("Press"=>p)
gphys1 = gphys1 - gphys1tmp

#gphys0 = gphys0 + 1.0e-28
#gphys1 = gphys1 + 1.0e-28
gphys0 = gphys0 + 1.0e-40
gphys1 = gphys1 + 1.0e-40

#gphys0 = gphys0 * 4e27
#gphys1 = gphys1 * 4e27

#ncfn  = "out-dwn1e0-lw-lor/LW_Case20_Earth_MidLatSummer_H2OOnly_Spectral_Flux.nc"
#ncfn  = "out-dwn1e0-lw-fs85/LW_Case20_Earth_MidLatSummer_H2OOnly_Spectral_Flux.nc"
#ncfn  = "out-dwn1e0-lw-width/LW_Case20_Earth_MidLatSummer_H2OOnly_Spectral_Flux.nc"
#ncfn  = "out-dwn1e0-lw/LW_Case20_Earth_MidLatSummer_H2OOnly_Spectral_Flux.nc"
#vname = "DelOptDep"
#gphys2 = GPhys::IO.open( ncfn, vname )
#gphys2 = gphys2.cut("PressLC"=>1e5).cut("WaveNum"=>wn1..wn2)


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

DCL.sldiv('y',1,3)
DCL.sgpset('lclip', true)
DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)
if flaglog then
#  GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-30,-21]
#  GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-27,-21]
  GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-31,-24]
#  GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-35,-26]
#  GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-28,-25]
else
  GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,0,1e-22]
end

#gphys1[(gphys1.lt 1.0e-25).where] = 1.0e-25
#gphys0[(gphys0.lt 1.0e-25).where] = 1.0e-25

if flaglog then
  gphys1.long_name = 'log10(abs.coef.)'
  GGraph.line gphys1.log10, true , 'legend'=>'my calculation', 'annotate'=>false
  GGraph.line gphys0.log10, false, 'index'=>20, 'legend'=>'LBLRTM', 'annotate'=>false
  GGraph.line gphys1.log10, false, 'legend'=>'my calculation', 'annotate'=>false
else
  gphys1.long_name = 'abs.coef.'
  GGraph.line gphys1, true , 'legend'=>'my calculation', 'annotate'=>false
  GGraph.line gphys0, false, 'index'=>20, 'legend'=>'LBLRTM', 'annotate'=>false
  GGraph.line gphys1, false, 'legend'=>'my calculation', 'annotate'=>false
end
#
#GGraph.line gphys1*factor, false, 'index'=>30, 'legend'=>'(my calculation)*'+factor.to_s
#GGraph.line gphys2, false, 'index'=>40, 'legend'=>'test'

wn = gphys1.coord('WaveNum').val
wn = VArray.new(wn,{"units"=>"m-1"}, "wn")
gphys0ip = gphys0.interpolate(wn)
p gphys1-gphys0ip

gphyszero = gphys1.copy
gphyszero[true] = 0.0

GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-1e-24,1e-24]
#GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-1e-30,1e-30]

gphyszero.long_name = 'diff.'

GGraph.line gphyszero, true, 'type'=>4, 'annotate'=>false
GGraph.line gphys1-gphys0ip, false, 'legend'=>'difference', 'annotate'=>false
#GGraph.line gphys1*factor-gphys0ip, false, 'index'=>30, 'legend'=>'(my calculation)*'+factor.to_s
#GGraph.line gphys2-gphys0ip, false, 'index'=>40, 'legend'=>'test'

#GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-1,1]
GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,-0.5,0.5]
#GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.85,0.1,0.2], 'window'=>[wn1,wn2,0.0,1.1]

gphyszero.long_name = 'rel.err.'
gphyszero.units = '1'

gprelerr = (gphys1-gphys0ip)/((gphys1+gphys0ip)/2)
#gprelerr = gphys0ip/gphys1

GGraph.line gphyszero, true, 'type'=>4, 'annotate'=>false
GGraph.line gprelerr, false, 'legend'=>'ratio', 'annotate'=>false
#gprelerr[(gphys0ip.lt abscoefthreshold).where] = 0.0
#GGraph.line gprelerr, false, 'index'=>40

#wn = gprelerr.coord('wn').val
#a = - 1.0 / ( 25.0e2 )**2
##a = - 1.0 / (  5.0e2 )**2
#b = 1
#for i in 0..wn.size-1
#  gprelerr[i] = a * ( wn[i] - 984.111820e2 )**2 + b
#end
#GGraph.line gprelerr, false, 'legend'=>'ratio', 'annotate'=>false, 'index'=>30, 'type'=>2

#GGraph.line (gphys1*factor-gphys0ip)/gphys0ip, false, 'index'=>30, 'legend'=>'(my calculation)*'+factor.to_s
#GGraph.line (gphys2-gphys0ip)/gphys0ip, false, 'index'=>40, 'legend'=>'test'

DCL.grcls
