#!/bin/sh


# Usage:
#   $ pjsub sample.sh


#----- pjsub option -----#
##PJM -L "rscgrp=small"
#PJM -L "rscgrp=medium"
##PJM -L "rscgrp=large"

#####-----
## 1 node, 1 process (1 thread) (PROBABLY NOT USED)
##PJM -L "node=1"
#####-----
## 1 node, 16 processes (flat MPI, 1 thread)
##PJM -L "node=1"
##PJM --mpi "proc=16"
#####-----
## 4 node, 64 processes (flat MPI, 1 thread)
##PJM -L "node=4"
##PJM --mpi "proc=64"
#####-----
## 12 node, 192 processes (flat MPI, 1 thread)
##   This will work for dwn=1.0d-1 cm-1 resolution
#PJM -L "node=12"
#PJM --mpi "proc=192"
#####-----
## 24 node, 384 processes (flat MPI, 1 thread)
##PJM -L "node=48"
##PJM --mpi "proc=768"
#####-----
## 48 node, 768 processes (flat MPI, 1 thread)
##PJM -L "node=48"
##PJM --mpi "proc=768"
#####-----

##PJM -L "elapse=10:00"
##PJM -L "elapse=60:00"
#PJM -L "elapse=720:00"
#PJM -j
#----- pjsub execution -----#

#export FORT90L=-Wl,-T
#a.out

# serial job
date
mpiexec -n 192 ./calc_ac_many
date

