#!/usr/bin/ruby

# http://taro-tnk.hatenablog.com/entry/2012/12/17/001552
def float_string?(str)
  Float(str)
  true
rescue ArgumentError
  false
end

indir = "data1"
infile = ["Warren1986_p2665.txt", "Warren1986_p2667.txt"]
outdir = "data2"


for ifile in 0..2-1

  # Preparation
  columns = [[""]]
  for i in 2..9
    columns << [""]
  end
#  p columns

  fn = indir+"/"+infile[ifile]
  File.open(fn, mode = "rt"){|f|
    f.each_line{|line|
      line = line.split(" ")
      if line.length != 9 then
        print "Error: Unexpected length of array: ", line, "\n"
        exit
      end
#      print line, "\n"
      for i in 0..9-1
        columns[i] << line[i]
      end
#    print columns, "\n"
    }
  }

  for n in 1..3
    outfile = outdir + "/" + infile[ifile][0..-5] + "-" + n.to_s + ".txt"
    print "Output: ", outfile, "\n"
    File.open(outfile, "w") do |f|
      for i in 3*(n-1)..3*n-1
        for l in 0+1..columns[0].length-1
          #      print columns[i][l], "\n"
          f.puts(columns[i][l]+"\n")
        end
      end
    end
  end

end
