# This script is applicable to aercntnm_mt_ckd_2.5.2.tar.gz.

#!/bin/bash

orgsrcdir="./cntnm/src"
newsrcdir="./src"

nowrite="--nowrite"
nowrite=""

#
# split a code (create a separate file which contains procedures only)
#
tail -131 ${newsrcdir}/cntnm_progr.f90 > ${newsrcdir}/cntnm_progr_procedures.f90
#
# create contnm_mod.f90 by modifing following points in contnm.f90
#   * xlength is added to argument of subroutine contnm
#   * WTOT is calculated by WTOT = XLOSMT*(PAVE/1013.)*(273./TAVE)* xlength
#   * delete write sentences in l.989-993

#sed -e '237,240d' ${newsrcdir}/contnm.f90 \
#    | sed -e '237i \ \ \ WTOT = XLOSMT*(PAVE/1013.)*(273./TAVE)* xlength' \
#    | sed s/"SUBROUTINE\ CONTNM(JRAD)"/"SUBROUTINE\ CONTNM(JRAD,xlength)"/ \
#    | sed -e '989,993d' \
#    > ${newsrcdir}/contnm_mod.f90
#sed s/contnm.f90/contnm_mod.f90/g ${newsrcdir}/cntnm_progr_procedures.f90 > ${newsrcdir}/cntnm_progr_procedures_mod.f90

sed -e '253,256d' ${newsrcdir}/contnm.f90 \
    | sed -e '253i \ \ \ WTOT = XLOSMT*(PAVE/1013.)*(273./TAVE)* xlength' \
    | sed s/"SUBROUTINE\ CONTNM(JRAD)"/"SUBROUTINE\ CONTNM(JRAD,xlength)"/ \
    | sed -e '1151,1155d' \
    > ${newsrcdir}/contnm_mod.f90
sed s/contnm.f90/contnm_mod.f90/g ${newsrcdir}/cntnm_progr_procedures.f90 > ${newsrcdir}/cntnm_progr_procedures_mod.f90


## make test program cntnm_progr_no_n2_o2_rf.f90
#sed    -e "114i !      No N2 nor O2" ${newsrcdir}/cntnm_progr.f90 > ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90
#sed -i -e "115i \      xcnt(5)=0.0" ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90
#sed -i -e "116i \      xcnt(6)=0.0" ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90
#sed -i -e "117i \      xcnt(7)=0.0" ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90

# make test program V1
head -313 ${newsrcdir}/cntnm_progr.f90 > ${newsrcdir}/test01_main.f90
#echo "      Include 'cntnm_progr_procedures.f90'" >> ${newsrcdir}/test01_main.f90

# make test program V2
head -312 ${newsrcdir}/cntnm_progr.f90 | sed s/PROGRAM\ DRCNTNM/!PROGRAM\ DRCNTNM/g > ${newsrcdir}/test02_cntnm_progr_core.f90

