require "numru/ggraph"
include NumRu


ncfns = [
  "../out_hitemp_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_abw1.0/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_nocia/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_noxsc/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_co2co025/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_co2co100/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
  "../out_hitemp_dwn1e1_co2co250/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
]
labels = [
  'control',
  'air-broadening width x 1.0',
  'no CIA',
  'no XSC',
  'CO2 cutoff 25 cm|-1"',
  'CO2 cutoff 100 cm|-1"',
  'CO2 cutoff 250 cm|-1"',
]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-60_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-50_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-40_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-30_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitran_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#]
#labels = [
#  'control',
#  'S cutoff 10|-60" m(molecule)|-1"',
#  'S cutoff 10|-50" m(molecule)|-1"',
#  'S cutoff 10|-40" m(molecule)|-1"',
#  'S cutoff 10|-30" m(molecule)|-1"',
#  'HITRAN',
#]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e2/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e0/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#]
#labels = [
#  DCL::csgi(131)+'k=1 cm|-1"',
#  'control ('+DCL::csgi(131)+'k=0.1 cm|-1")',
#  DCL::csgi(131)+'k=0.01 cm|-1"',
#]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1_3spc/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_SO2_Flux.nc",
#  "../../../../radmodels-2018-01-23_test_Venus_Gas-Pollack/k-dist/prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_GQ02_all/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
#]
#labels = [
#  'control',
#  'H2O, CO2, SO2 only',
#  'gas vmrs by Pollack et al. (1993)',
#]


ncfnobs = [
  "data/Venus_LWNetFluxProfile_Revercomb-etal1985Fig4_Sounder.nc",
  "data/Venus_LWNetFluxProfile_Revercomb-etal1985Fig5_Day.nc",
  "data/Venus_LWNetFluxProfile_Revercomb-etal1985Fig6_Night.nc",
  "data/Venus_LWNetFluxProfile_Revercomb-etal1985Fig7_North.nc"
]


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)


#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)
DCL.sglset('LCLIP', true)
DCL.sglset('LCNTL', true)

GGraph.set_fig 'itr'=>2, 'viewport'=>[0.1,0.9,0.15,0.65], 'window'=>[0.0,200,100e5,0.001e5]

for ifile in 0..(ncfns.size-1)
  ncfn = ncfns[ifile]

  if ifile == 0 then
    flag_first = true
  else
    flag_first = false
  end

  vname = "RadUwFluxLW"
  gpup = GPhys::IO.open( ncfn, vname )
  vname = "RadDwFluxLW"
  gpdn = GPhys::IO.open( ncfn, vname )
  gp = gpup - gpdn

#ncfnobsup = "data/Venus_SWUpFluxProfile_Tomasko-etal1980.nc"
#vname = "upflux"
#gpobsup = GPhys::IO.open( ncfnobsup, vname )
#ncfnobsdn = "data/Venus_SWDnFluxProfile_Tomasko-etal1980.nc"
#vname = "dnflux"
#gpobsdn = GPhys::IO.open( ncfnobsdn, vname )

  gp = gp.copy
  gp.long_name = 'radiative flux'
  z = gp.axis('Press').pos
  z.long_name = 'pressure'
  gp.axis('Press').set_pos(z)

  if ncfns.size > 1 then
    label = labels[ifile]
  else
    label = nil
  end
  GGraph.line gp, flag_first, 'exchange'=>true, 'title'=>'',
              'index'=>(ifile+1)*10+1, 
              'legend'=>label, 'legend_vx'=>0.2

  if flag_first then

    for i in 0..ncfnobs.size-1
      vname = "netflux"
      gp = GPhys::IO.open( ncfnobs[i], vname )
      vpxs = NArray.float(gp.coord('plev').val.size)
      vpys = NArray.float(gp.coord('plev').val.size)
      for j in 0..gp.coord('plev').val.size-1
        vpxs[j] = gp.val[j]
        vpys[j] = gp.coord('plev').val[j]
      end
      r = 30 ; g = 30 ; b = 30
      if ( r >= 0 ) && ( g >= 0 ) && ( b >= 0 ) then
#    DCL::SGTNZU(vpxs.size,vpxs,vpys,1)
        DCL::sgtnxu(vpxs,vpys,5,DCL::isgrgb(r,g,b))
#    DCL::sgtnxu(vpxs,vpys,20,DCL::isgrgb(r,g,b))
      end
    #  GGraph.line gp, false, 'exchange'=>true, 'type'=>4

    end

  end


end

DCL.grcls
