#!/bin/bash

a_sza=( 037.9 077.8 180.0 )


for ((i=0; i < ${#a_sza[*]}; i++))
do
#    outdir="out-hitemp-dwn1e1/F2635.0_sza"${a_sza[$i]}"_wn10000e2-25000e2"
    outdir="out_hitemp_dwn1e1/F2635.0_sza"${a_sza[$i]}"_wn02000e2-50000e2"
    echo "-----"
    if [ ! -e $outdir ]; then
	echo "Directory "$outdir" does not exist."
	mkdir -p $outdir
#	exit
    fi
    echo 'sza       :' ${a_sza[$i]}
    cat Venus_sw_toa_alb_template_calc_rte.conf \
	| sed -e s@SEDSZA@${a_sza[$i]}@g \
	> calc_rte.conf
    cat Venus_sw_toa_alb_template_calc_rte_file.conf \
	| sed -e s@SEDSZA@${a_sza[$i]}@g \
	> calc_rte_file.conf
    ./calc_rte
done
