#!/bin/bash

a_sza=( 000.0 005.0 010.0 015.0 020.0 025.0 030.0 035.0 040.0 045.0 050.0 055.0 060.0 065.0 070.0 075.0 080.0 085.0 090.0 )


for ((i=0; i < ${#a_sza[*]}; i++))
do
#    outdir="out-hitemp-dwn1e1/F2635.0_sza"${a_sza[$i]}"_wn10000e2-25000e2"
    outdir="out_hitemp_dwn1e1/F2635.0_sza"${a_sza[$i]}"_wn05000e2-50000e2"
    echo "-----"
    if [ ! -e $outdir ]; then
	echo "Directory "$outdir" does not exist."
	mkdir -p $outdir
#	exit
    fi
    echo 'sza       :' ${a_sza[$i]}
    cat Venus_sw_sfc_dnf_template_calc_rte.conf \
	| sed -e s@SEDSZA@${a_sza[$i]}@g \
	> calc_rte.conf
    cat Venus_sw_sfc_dnf_template_calc_rte_file.conf \
	| sed -e s@SEDSZA@${a_sza[$i]}@g \
	> calc_rte_file.conf
    ./calc_rte
done
