require "numru/ggraph"
include NumRu


pardirs = [
  "../../prog03_calc_rte/out_hitemp_dwn1e1",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_abw1.0",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_nocia",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_noxsc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_co2co025",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_co2co025",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_co2co025",
]
labels = [
  'control',
  'air-broadening width x 1.0',
  'no CIA',
  'no XSC',
  'CO2 cutoff 25 cm|-1"',
  'CO2 cutoff 100 cm|-1"',
  'CO2 cutoff 250 cm|-1"',
]

#pardirs = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-60_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-50_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-40_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-30_dwn1e1",
#  "../../prog03_calc_rte/out_hitran_dwn1e1",
#]
#labels = [
#  'control',
#  'S cutoff 10|-60" m(molecule)|-1"',
#  'S cutoff 10|-50" m(molecule)|-1"',
#  'S cutoff 10|-40" m(molecule)|-1"',
#  'S cutoff 10|-30" m(molecule)|-1"',
#  'HITRAN',
#]

#pardirs = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e2",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp_dwn1e0",
#]
#labels = [
#  DCL::csgi(131)+'k=1 cm|-1"',
#  'control ('+DCL::csgi(131)+'k=0.1 cm|-1")',
#  DCL::csgi(131)+'k=0.01 cm|-1"',
#]

#labels = [
#  'model',
#]

#pardirs = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1_3spc",
#  "../../../../radmodels-2018-01-23_test_Venus_Gas-Pollack/k-dist/prog03_calc_rte/out_hitemp_dwn1e1"
#]
#labels = [
#  'control',
#  'H2O, CO2, SO2 only',
#  'gas vmrs by Pollack et al. (1993)',
#]


for idir in 0..(pardirs.size-1)
  if idir == 0 then
    flag_first = true
  else
    flag_first = false
  end

  pardir = pardirs[idir]

  ncfns = [
    pardir+"/F2635.0_sza000.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza005.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza010.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza015.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza020.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza025.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza030.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza035.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza040.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza045.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza050.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza055.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza060.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza065.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza070.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza075.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza080.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza085.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc",
    pardir+"/F2635.0_sza090.0_wn05000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Flux.nc"
  ]

  na_sza     = NArray.float(ncfns.size)
  na_netflux = NArray.float(ncfns.size)

  for i in 0..ncfns.size-1
    ncfn = ncfns[i]
    na_sza[i] = 5*i
    na_sza[i] = NMath::cos(na_sza[i]*3.141592/180.0)
    #
    vname = "RadUwFlux"
    vname = "RadUwFluxSW"
    gpup = GPhys::IO.open( ncfn, vname )
    vname = "RadDwFlux"
    vname = "RadDwFluxSW"
    gpdn = GPhys::IO.open( ncfn, vname )
    na_netflux[i] = gpdn.cut('Press'=>1e10).val[0] - gpup.cut('Press'=>1e10).val[0]
  end


  va_sza = VArray.new( na_sza,
                       {"long_name"=>"cos(solar zenith angle)", "units"=>"1"},
                       "sza" )
  ax_sza = Axis.new.set_pos(va_sza)
  va_netflux = VArray.new( na_netflux,
                           {"long_name"=>"net flux", "units"=>"W m-2"},
                           "netflux" )
  gphys = GPhys.new( Grid.new(ax_sza), va_netflux )


  ncfn = "data/Venus_SWFluxAtSfc_Moroz-etal1985.nc"
  ncfn = "data/Venus_SWFluxAtSfc.nc"
  vname = "netflux"
  gpobs = GPhys::IO.open( ncfn, vname )

  na_cossza = gpobs.coord('sza').val
  na_cossza = NMath::cos(na_cossza*3.141592/180.0)
  va_cossza = VArray.new( na_cossza,
                          { "long_name"=>'cos(solar zenith angle)',
                            "units"=>'1' }, "sza" )
  gpobs.axis('sza').set_pos(va_cossza)
  gpobs = gpobs.copy
  gpobs.long_name = "net flux"
  gpobs.units = 'W m|-2"'


  if flag_first then
    iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
    DCL.gropn(iws)

    #DCL.sldiv('y',1,4)
    DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
    DCL.sgpset('lfull',true)
    DCL.uzfact(0.6)
    DCL.sglset('LCLIP', true)
    DCL.sglset('LCNTL', true)

    GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.9,0.15,0.6],
                   #               'window'=>[0,90,0.0,100]
                   'window'=>[0,1,0.0,100]
    GGraph.mark gpobs, true, 'exchange'=>false, 'index'=>10, 'legend_vx'=>0.25, 'legend'=>'observation', 'title'=>''

  end

  GGraph.line gphys, false, 'exchange'=>false, 'title'=>'',
              'index'=>(idir+1)*10+1,
              'legend_vx'=>0.2, 'legend'=>labels[idir]

end

DCL.grcls
