require "numru/ggraph"
include NumRu


ncfns = [
  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_abw1.0/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_nocia/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_noxsc/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_co2co025/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_co2co100/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_co2co250/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
]
labels = [
  'control',
  'air-broadening width x 1.0',
  'no CIA',
  'no XSC',
  'CO2 cutoff 25 cm|-1"',
  'CO2 cutoff 100 cm|-1"',
  'CO2 cutoff 250 cm|-1"',
]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-60_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-50_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-40_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp-30_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitran_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#]
#labels = [
#  'control',
#  'S cutoff 10|-60" m(molecule)|-1"',
#  'S cutoff 10|-50" m(molecule)|-1"',
#  'S cutoff 10|-40" m(molecule)|-1"',
#  'S cutoff 10|-30" m(molecule)|-1"',
#  'HITRAN',
#]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e2/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e0/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#]
#labels = [
#  DCL::csgi(131)+'k=1 cm|-1"',
#  'control ('+DCL::csgi(131)+'k=0.1 cm|-1")',
#  DCL::csgi(131)+'k=0.01 cm|-1"',
#]

#ncfns = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1_3spc/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_SO2_Spectral_Flux.nc",
#  "../../../../radmodels-2018-01-23_test_Venus_Gas-Pollack/k-dist/prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_sza180.0_wn02000e2-50000e2/Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc",
#]
#labels = [
#  'control',
#  'H2O, CO2, SO2 only',
#  'gas vmrs by Pollack et al. (1993)',
#]


def mkwlobj( gp )

  namelev = "WaveNum"
  wn = gp.coord(namelev)

  gp = gp.copy
  wl = 1.0/wn

  gp = gp / wl**2
  #  gp = gp * wl

  #  wl = wl.convert_units( Units['micron'] )
  wl.long_name = "wavelength"
  vawl = wl.convert_units( Units['micron'] )
  #  vawl = VArray.new( wl.val, { "long_name"=>'wavelength', "units"=>wl.units.to_s }, namelev )
  gp.axis(namelev).set_pos(vawl)

  gp.long_name = "flux"

  # conversion from W m-2 m-1 to W m-2 (micron)-1
  gp = gp * 1e-6
  # conversion from W m-2 (micron)-1 to mW m-2 (micron)-1
  gp = gp * 1e3
  # conversion from W m-2 (micron)-1 to W m-2 (micron)-1 (sr)-1
  gp = gp / 3.141592
    gp.units = 'mWm|-2"(micron)|-1"(sr)|-1"'
#  gp.units = 'Wm|-2"('+DCL::csgi(163)+'m)|-1"'

  return gp
end

for ifile in 0..(ncfns.size-1)
  if ifile == 0 then
    flag_first = true
  else
    flag_first = false
  end

  ncfn = ncfns[ifile]


  vname = "RadUwFlux"
  gphys = GPhys::IO.open( ncfn, vname )
  gphys = gphys.cut('Press'=>0)
  gphys = mkwlobj( gphys )

  nrunmean = 100
#  if ifile == 0 then
#    nrunmean = 10
#  elsif ifile == 1 then
#    nrunmean = 100
#  else
#    nrunmean = 1000
#  end
  gphys = gphys.running_mean('WaveNum',nrunmean)


  if flag_first then
    iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
    DCL.gropn(iws)


    #DCL.sldiv('y',1,4)
    DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
    DCL.sgpset('lfull',true)
    DCL.uzfact(0.6)
    DCL.sglset('LCLIP', true)
    DCL.sglset('LCNTL', true)
    GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.15,0.9,0.15,0.6], 'window'=>[1.0,4.0,0.0,150]
  end

  if ncfns.size > 1 then
    label = labels[ifile]
  else
    label = nil
  end
  GGraph.line gphys, flag_first, 'exchange'=>false, 'annotate'=>false,
              'title'=>'',
              'index'=>(ifile+1)*10+1,
              'legend_vx'=>0.6, 'legend'=>label
end

DCL.grcls
