set term x11
set term postscript eps color 24

set nokey

set xlabel "wavelength (micron meter)"
set logscale x

set output "fig_Qext.eps"
unset logscale y
set ylabel "extinction efficiency factor"
plot "zzz" u ($1*1e6):3 w l

pause -1

set output "fig_coalb.eps"
set logscale y
set ylabel "single scattering co-albedo"
plot "zzz" u ($1*1e6):5 w l

pause -1

set output "fig_af.eps"
unset logscale y
set ylabel "asymmetry factor"
plot "zzz" u ($1*1e6):6 w l
